/*
 *  Mixer.cpp
 *  mosievius
 *
 *  Created by Ari Lazier on Sun Mar 30 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */

#import "Mixer.h"
#import "Sieve.h"
#import "SKIN.h"

bool midiactive;

int mix(char* buffer, int buffer_size, void *data)
{
	Mixer *m = (Mixer *)data;
	float byte2, byte3, *buf = (float *)buffer, *temp;
	int i;
        BOOL key;
	Sieve *s;
        NSWindow *nswin = [NSApp keyWindow];
	
        if(midiactive == YES)
        {
            for(i = 0; i < 8; i++)
            {
                m->control[i] = -1;
                m->toggle[i] = -1;
            }
            int type, channel;
            while((type = m->midi->nextMessage()) > 0)
            {
                byte2 = m->midi->getByteTwo();
                byte3 = m->midi->getByteThree();
                channel = m->midi->getChannel();
                if(type != __SK_ControlChange_ || byte2!=7) m->toggle[channel] = !byte2;
                else m->control[channel] = byte3/128.0;
            }
        }
	for(i = 0; i < buffer_size; i++) buf[i*2] = buf[i*2+1] = 0;	
	for(i = 0; i < [m->list count]; i++)
	{
		s = [m->list objectAtIndex:i];
                if(nswin == [s window] && midiactive == YES) key = YES;
                else key = NO;
		if([[s getState] isEqualToString:@"Active"]) [s tick:buf OfSize:buffer_size isKey:key];
	}
	return 0;
}



Mixer::Mixer(NSMutableArray *l)
{
    list = l;
    hopSize = 2048;
    running = FALSE;
    try
    {
        io = new RtAudio(&stream, 0, 2, 0, 2, RtAudio::RTAUDIO_FLOAT32, 44100, &hopSize, 4);
    }
    catch(RtError &error) { exit(0); }
    try
    {
        midiactive = YES;
        midi = new RtMidi();
    }
    catch (StkError &exception)
    {
        midiactive = NO;
    }
    return;
}

void
Mixer::startAudio()
{
	if(running == FALSE)
	{
            io->setStreamCallback(stream, &(mix), (void *)(this));
            io->startStream(stream);
	}
	return;
}

void
Mixer::stopAudio()
{
	if(running == TRUE)
	{
	  io->stopStream(stream);
		io->closeStream(stream);
  }
	return;
}

















