/* Sieve */

#import <Cocoa/Cocoa.h>
#import "fvec.h"
#import "Sieve_back.h"
#import "Mixer.h"

#define BUFFERS 16
#define WINSIZE 4096

@interface Sieve : NSWindowController
{
	IBOutlet id displayThresh;
        IBOutlet id setVelocity;
	IBOutlet id setSliders;
        IBOutlet id setMemory;
        IBOutlet id setModes;
        IBOutlet id presetTable;
        IBOutlet id presetName;
        NSMutableArray *presetArray;
	NSString *path;
	NSString *name;
	NSString *state;
	float vol;
	Sieve_back *meat;
        id master;
        Mixer *mix;
}
- (void)initialize:(id)string table:(id)table mixer:(Mixer *)m;
- (void)cleanup:(id)i;
- (id)getPath;
- (id)getName;
- (id)getState;
- (IBAction)recieveMode:(id)sender;
- (IBAction)recieveThresh:(id)sender;
- (IBAction)power:(id)sender;
- (IBAction)volume:(id)sender;
- (IBAction)memory:(id)sender;
- (IBAction)presets:(id)sender;
- (void)setPreset:(id)sender;
- (void)extraction:(id)sender;
- (void)tick:(float *)buffer OfSize:(int)size isKey:(BOOL)key;
@end
