/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/**
   \class BaseAudio
   \brief Interface for real-time audio device IO
   
   Abstract base class used as interface for Real-time BaseAudio IO.
*/




#if !defined(__BaseAudio_h)
#define __BaseAudio_h

#include "MSignal.h"

class BaseAudio: public MSignal
{
protected:
  unsigned int channels_;
  unsigned int mode_;
  short *sdata_;
  unsigned int winSize_;
  

public:
  BaseAudio(unsigned int srate, unsigned int channels, unsigned int mode, unsigned int winSize);
  virtual ~BaseAudio();
  virtual void get(fvec &win, unsigned long index) = 0;
  virtual void put(fvec &win, unsigned long index) = 0;
  
  
};




#endif


	
