/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/**
   \class Collection
   \brief List of files

   List of files used for batch processing.
*/

#if !defined(__Collection_h)
#define __Collection_h

#include <stdio.h>

#include <vector>
#include <fstream.h>
#include <string.h>
#include <iostream.h>
using namespace std;


class Collection
{
private:
  vector<string> collectionList_;
  string name_;
public:
  Collection();
  ~Collection();
  unsigned int size();
  void setName(string name);
  string entry(unsigned int i);
  void add(string entry);
  string name();
  void shuffle();
  void read(string filename);
  void write(string filename);
  friend ostream& operator<<(ostream&, const Collection&);
  friend istream& operator>>(istream&, Collection&);
};







#endif
