/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "ColorPlot.h"

ColorPlot::ColorPlot()
{
}
  
	
ColorPlot::~ColorPlot()
{
}


void
ColorPlot::operator=(const ColorPlot& a)
{
}
  

ColorPlot::ColorPlot(const ColorPlot& a)
{
}

/* int
ColorPlot::get_size()
{
}
*/

void
ColorPlot::init(string name, fvec rvalues, fvec gvalues, fvec bvalues)
{
  name_  = name;
  int size = rvalues.size();
  rvalues_.create(size);
  gvalues_.create(size);
  bvalues_.create(size);
  
  rvalues_ = rvalues;
  gvalues_ = gvalues;
  bvalues_ = bvalues;
}





  
void 
ColorPlot::write(string filename)
{
  int size = rvalues_.size();
  ofstream to(filename.c_str());
  if (!to)
    {
      cerr << "Problem opening file " << filename << endl;
      exit(1);
    }
  to << name_ << endl;
  to << size << endl;
  for (int i=0; i<size; i++)
    {
      to << rvalues_(i) << " " << gvalues_(i) << " " << bvalues_(i) << endl;
    }
}



void
ColorPlot::send(Communicator* com)
{
  static char *buf = new char[256];
  string message;
  sprintf(buf, "%s\n", name_.c_str());
  int size = rvalues_.size();
  sprintf(buf, "%i\n", size);
  message = buf;
  com->send_message(message);
  for (int i=0; i<size; i++)
    {
      sprintf(buf, "%f %f %f\n", rvalues_(i), gvalues_(i), bvalues_(i));
      message = buf;
      com->send_message(message);
    }
  cerr << size << " numbers were sent to the client\n";
}


	
