/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/** 
    \class ColorPlot
    \brief Three vectors of color values

*/




#if !defined(__ColorPlot_h)
#define __ColorPlot_h


#include <math.h>
#include "fvec.h"



class ColorPlot
{
protected:
  fvec rvalues_;
  fvec gvalues_;
  fvec bvalues_;
  string name_;
  
  
public:
  ColorPlot();
  ~ColorPlot();
  ColorPlot(const ColorPlot& a);
  void operator=(const ColorPlot& a);
  void init(string name, fvec rvalues, fvec gvalues, fvec bvalues);
  void send(Communicator* com);
  void write(string filename);
};



#endif



	

	
