/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/**
   \class DWTC
   \brief Features based on the DWT

   Features based on the Discrete Wavelet Transform. 
*/

#if !defined(__DWTC_h)
#define __DWTC_h

#include "System.h"	
#include "DB.h"
#include "MagFFT.h"
#include "Hamming.h"
#include "Series.h"
#include "ShapeDesc.h"
#include "Zcrs.h"
#include "Memory.h"
#include "RMS.h"
#include "WaveletPyramid.h"
#include "Daub4.h"
#include "NormRMS.h"
#include "MSignal.h"

class DWTC: public System
{
private:
  Daub4 *daub4_;
  WaveletPyramid *pyramid_;
  fvec res_;
  NormRMS *norm_;
public:
  DWTC();
  DWTC(MSignal *src);
  ~DWTC();
  void init();
  void process(fvec& in, fvec& out);
};

#endif

	
