/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/** 
    \class Daub4
    \brief Daubechies4 WaveletStep

   Applies the Daubechies 4-coefficient wavelet filter as 
a WaveletStep for the WaveletPyramid algorithm. The code is 
is based on the Numerical Recipies wavelet code. 
*/

#if !defined(__Daub4_h)
#define __Daub4_h

#include "System.h"	
#include "defs.h"
#include "WaveletStep.h"

class Daub4: public WaveletStep
{
private:
  int direction_;
  fvec workspace_;
  float c0_;
  float c1_;
  float c2_;
  float c3_;
public:
  Daub4();
  Daub4(unsigned int inSize, int direction);
  void process(fvec& in, fvec& out);
  
};

#endif
