/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/** 
    \class LabelList
    \brief Labels for classification

    LabelList hols a vector of Labels that can be used for classification.
*/




#include "LabelList.h"


LabelList::LabelList()
{
  labelList_.reserve(1000);
}



LabelList::~LabelList()
{
}

vector<string> 
LabelList::getLabels()
{
  return labelList_;
}


ostream& 
operator<<(ostream& o, const LabelList& l)
{
  o << "# MARSYAS LabelList " << endl;
  o << "# name = " << l.name_ << endl;
  for (unsigned int i=0; i < l.labelList_.size(); i++)
    {
      o << l.labelList_[i] << endl;
    }
  return o;
}



unsigned int 

LabelList::size()
{
  return labelList_.size();
}


string
LabelList::name()
{
  return name_;
}


string 
LabelList::entry(unsigned int i)
{
  return labelList_[i];
}



istream& 
operator>>(istream& i, LabelList& l)
{
  string str0, str1, str2;
  string labelEntry;
  string str;
  
  i >> str0;
  i >> str1;
  i >> str2;
  
  if ((str0 != "#") || ( str1 != "MARSYAS") || (str2 != "LabelList"))
    {
      cerr << "Problem reading LabelList from istream" << endl;
      return i;
    }

  i >> str0;
  i >> str1;
  i >> str2;
  i >> l.name_;

  while (i >> labelEntry)
    {
      l.labelList_.push_back(labelEntry);
    }
  return i;
}


  






	
