/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/** 
    \class LabelList
    \brief Labels for classification

    LabelList hols a vector of Labels that can be used for classification.
*/

#if !defined(__LabelList_h)
#define __LabelList_h


#include <fstream.h>
#include <iostream.h>
#include <vector>
#include <string.h>
using namespace std;

class LabelList
{
private:
  vector<string> labelList_;
  string name_;
public:
  LabelList();
  ~LabelList();
  unsigned int size();
  string entry(unsigned int i);
  string name();
  vector<string> getLabels();
  friend ostream& operator<<(ostream&, const LabelList&);
  friend istream& operator>>(istream&, LabelList& );  
};




#endif
