/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/



/**
   \class Norm
   \brief Normalize 

   Normalized by substracting mean and dividing by standard deviation.
*/



#include "Norm.h"

Norm::Norm()
{
  inSize_ = DEFAULT_WIN_SIZE;
  outSize_ = DEFAULT_WIN_SIZE;
}

Norm::Norm(unsigned int inSize)
{
  inSize_ = inSize;
  outSize_ = inSize;
}



Norm::~Norm()
{
}

void 
Norm::process(fvec& in, fvec& out) 
{
  assert((in.size() == inSize_) && (out.size() == outSize_));  
  unsigned int i;
  float mean = in.mean();
  float std = in.std();
  for (i=0; i< inSize_; i++)
    {
      out(i) = 0.05 * ((in(i) - mean) / std); // Scale to -1.0 1.0 audio range
      //out(i) = in(i) - mean;
    }
}


	

	
