/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/**
   \class  Segmentor
   \brief  Interface for segmentors

   Abstract base class used as interface for segmentors. Segmentors 
   as input a FeatMatrix and produce a temporal segmentation 
   of the FeatMatrix into regions in time stored as 1.0 and 0.0 
   in a fvec. 
*/


/* Segmentor:
   Generic interface for segmentor classes. Segmentors take 

*/


#if !defined(__Segmentor_h) 
#define __Segmentor_h

#include <string.h>
#include "FeatMatrix.h"
#include "fvec.h"

class Segmentor
{
protected:
  string type_;
  
public:
  Segmentor();
  virtual ~Segmentor();
  virtual void segment(FeatMatrix& fmatrix, fvec &peaks) = 0;
};



#endif

   
