/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


/** 
    \class Util
    \brief Various utilities

    Util is a class bundling together various rather 
unrelated convenience utilities. 
*/


	


#if !defined(__Util_h)
#define __Util_h

#include "MSignal.h"
#include <string.h>
#include "AuFileIO.h"
#include "AiffFileIO.h"
#include "SoundFileIO.h"
#include "WavFileIO.h"
#include "Mp3FileIO.h"


class Util
{
private:
  void check_type();
  string filename_;
  MSignal* specificIO_;
  
  
public:
  Util();
  ~Util();  
  SoundFileIO *sfopen(string filename, int mode);
  
};



	

#endif
