/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/** 
    \class ValleyPick
    \brief Pick valley

    Simple Subsample Valley Pick.
*/

#if !defined(__ValleyPick_h)
#define __ValleyPick_h

#include "System.h"	

class ValleyPick: public System
{
private:
  unsigned int maxPeriod_;
  unsigned int minPeriod_;
  
public:
  ValleyPick();
  ValleyPick(unsigned int inSize);
  ~ValleyPick();
  void process(fvec& in, fvec& out);
};

#endif
