/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>

#include "FeatMatrix.h"
#include "MSignal.h"
#include "fmatrix.h"
#include "SoundFileIO.h"
#include "defs.h"
#include "Util.h"
#include "Gain.h"
#include "Hamming.h"
#include "MagFFT.h"
#include "FeatExtractor.h"
#include "LabelList.h"
#include "Collection.h"


void 
concat(string ffile1, string ffile2)
{
  FeatMatrix fmatrix1;
  FeatMatrix fmatrix2;
  
  
  ifstream ffile_s1(ffile1.c_str());
  ifstream ffile_s2(ffile2.c_str());
  
  ffile_s1 >> fmatrix1;
  ffile_s2 >> fmatrix2;

  FeatMatrix result(fmatrix1.rows(), fmatrix1.cols() + fmatrix2.cols());
  result.concat(fmatrix1, fmatrix2);
  
  string outfile = ffile2 + "c";
  cout << "Writing : " << outfile << endl;
  ofstream out(outfile.c_str());
  out << result;
}

 

int
main(int argc, char **argv)
{
  if (argc != 3)
    {
      cerr << "Usage :" << argv[0] <<" collection1 collection2\n";
      exit(1);
    }
  string collection1str = MARSYAS_MFDIR;
  collection1str += "/collections/"; 
  collection1str += argv[1];

  string collection2str = MARSYAS_MFDIR;
  collection2str += "/collections/";
  collection2str += argv[2];
  ifstream from1(collection1str.c_str());
  Collection l1;
  from1 >> l1;
  ifstream from2(collection2str.c_str());
  Collection l2;
  from2 >> l2;
  for (unsigned int i=0; i<l1.size(); i++)
    {
      concat(l1.entry(i), l2.entry(i));
    }
  return 0;
}
