/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>

#include "FeatMatrix.h"
#include "MSignal.h"
#include "fmatrix.h"
#include "SoundFileIO.h"
#include "defs.h"
#include "Util.h"
#include "Gain.h"
#include "Hamming.h"
#include "MagFFT.h"
#include "FeatExtractor.h"
#include "LabelList.h"
#include "Collection.h"

void 
join(Collection collection, string result)
{
  vector <FeatMatrix *> matrices;
  matrices.reserve(100);
  unsigned int collectionSize = collection.size();
  unsigned int i;
  
  for (i=0; i< collectionSize; i++)
    {
      matrices.push_back(new FeatMatrix());
      matrices[i]->read(collection.entry(i));
      cout << "Reading FeatMatrix file :" << collection.entry(i) << endl;
    }
  FeatMatrix fmatrix(matrices);
  ofstream to(result.c_str());
  to << fmatrix;
}

 

int
main(int argc, char **argv)
{
  if (argc != 3)
    {
      cerr << "Usage :" << argv[0] <<" collection result\n";
      exit(1);
    }
  string collectionstr = MARSYAS_MFDIR;
  collectionstr += "/collections/";
  collectionstr += argv[1];

  
  ifstream from(collectionstr.c_str());
  Collection l;
  from >> l;
  string result = argv[2];
  join(l, result);
  return 0;
}
