/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>
#include "FeatMatrix.h"
#include "MSignal.h"
#include "fmatrix.h"
#include "SoundFileIO.h"
#include "defs.h"
#include "Util.h"
#include "Gain.h"
#include "Hamming.h"
#include "MagFFT.h"
#include "FeatExtractor.h"
#include "Series.h"
#include "MagDB.h"
#include "Sine.h"
#include "Spectral.h"
#include "LabelList.h"
#include "Collection.h"
#include "Gaussian.h"

void 
classify(string classifierStr, string resStr)
{
  Gaussian classifier;
  ifstream classifierFrom(classifierStr.c_str());
  classifierFrom >> classifier;

  FeatMatrix res;
  res.read(resStr);
  
  classifier.classifyFeatMatrix(res);
}



 

int
main(int argc, char **argv)
{
  if (argc != 3)
    {
      cerr << "Usage :" << argv[0] <<" Classifier resFeatMatrix\n";
      exit(1);
    }
  string classifyStr = MARSYAS_MFDIR;
  classifyStr += "/classifiers/";
  classifyStr += argv[1];
  
  string resStr = argv[2];
  classify(classifyStr, resStr);
  return 0;
}
