/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>

#include "FeatMatrix.h"
#include "MSignal.h"
#include "fmatrix.h"
#include "defs.h"
#include "Collection.h"


 

int
main(int argc, char **argv)
{
  if (argc == 1)
    {
      cerr << "Usage :" << argv[0] << " extractor collections matrix \n";
      exit(1);
    }
  unsigned int numClasses = argc -3;
  unsigned int size;
  unsigned int cl;
  unsigned int m;
  string extractorStr = argv[1];
  cout << "Extractor = " << extractorStr << endl;
  
  for (cl = 0; cl < numClasses; cl++)
    {
      cout << "Class " << cl << " collection is :" << argv[cl+2] << endl;
    }
  
  
  // vector <FeatMatrix *> allMatrices;
  // allMatrices.reserve(1000);
  
  FeatMatrix trainMatrix(numClasses * 100 * 1292, 19);
  trainMatrix.setval(0.0);

  FeatMatrix *tempMatrix;

  unsigned int count = 0;
  for (cl = 0; cl < numClasses; cl++)
    {
      string collectionstr = MARSYAS_MFDIR;
      string cname = argv[cl+2];
      cname = cname.substr(0, cname.size()-3); // remove .mf
      collectionstr += "/featurefiles/";
      collectionstr += cname;
      collectionstr += extractorStr;
      collectionstr += ".mf";
      ifstream from(collectionstr.c_str());
      // allMatrices.push_back(new FeatMatrix());
      // while (from >> *(allMatrices[count]))
      FeatMatrix *tempMatrix;
      tempMatrix = new FeatMatrix();
      while (from >> *(tempMatrix))
	{
	  //allMatrices.push_back(new FeatMatrix());
	  trainMatrix.paste(count * 1292, tempMatrix);
	  cout << "read " << tempMatrix->name() << endl;
	  count++;
	  delete tempMatrix;
	  tempMatrix = new FeatMatrix();
	}
      // allMatrices.pop_back();
    }
  string result = argv[argc-1];
  /* FeatMatrix trainMatrix(allMatrices); */
  exit(1);
  
  
  
  /* 
  fmatrix covariance = trainMatrix.covariance();
  fvec meanRow = trainMatrix.meanRow();
  fvec stdRow = trainMatrix.stdRow();
  cout << meanRow << endl;
  cout << stdRow << endl;
  */
  // fmatrix correlation = trainMatrix.correlation();
  /* 
  ofstream to(result.c_str());
  to << covariance;
  */
  // to << correlation << endl;
  return 0;
}
