/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>

#include "FeatMatrix.h"
#include "MSignal.h"
#include "fmatrix.h"
#include "SoundFileIO.h"
#include "defs.h"
#include "Util.h"
#include "Gain.h"
#include "Hamming.h"
#include "MagFFT.h"
#include "FeatExtractor.h"
#include "LabelList.h"



void 
label(string ffile, string labelfile, int label)
{
  FeatMatrix fmatrix;
  ifstream ffile_s(ffile.c_str());
  ifstream lfile_s(labelfile.c_str());
  
  ffile_s >> fmatrix;
  LabelList labels;
  lfile_s >> labels;

  cerr << "Labeling feature file " << ffile << " using labelfile " << labelfile << " with label " << label << "(" << labels.entry(label) << ")" << endl;
  

  // fmatrix.label(labels.getLabels(), label);
  
  ofstream out(ffile.c_str());
  out << fmatrix;
}

 

int
main(int argc, char **argv)
{
  if (argc != 4)
    {
      cerr << "Usage :" << argv[0] <<" featurefile labelfile label\n";
      exit(1);
    }
  string ffile = argv[1];
  string labelfile = argv[2];
  int i = atoi(argv[3]);
  label(ffile, labelfile, i);
  return 0;
}
