/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/* sfinfo:
   Command line utility for displaying soundfile information
*/

#if HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include "FeatMatrix.h"
#include "MSignal.h"
#include "fmatrix.h"
#include "SoundFileIO.h"
#include "defs.h"
#include "Util.h"
#include "Gain.h"
#include "Hamming.h"
#include "FeatExtractor.h"
#include "Series.h"


void 
info(string filename)
{
  MSignal *src;
  Util util;
  src = util.sfopen(filename, MRS_SF_READ);
  src->initWindow(512, 512, 0, 0);
  src->debug_info();
}
	
int 
main(int argc, char **argv)
{
  int secs;
  if (argc ==1)
    {
      cerr << "Usage :" << argv[0] << " filename\n";
      exit(1);
    }
  info(argv[1]);
  return 0;
}

	
