/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/* sfplay:
   Command line utility for playing soundfiles. 
*/



#include <stdio.h>
#include "FeatMatrix.h"
#include "MSignal.h"
#include "fmatrix.h"
#include "SoundFileIO.h"
#include "defs.h"
#include "Util.h"
#include "Gain.h"
#include "Hamming.h"
#include "MagFFT.h"
#include "FeatExtractor.h"
#include "Series.h"
#include "MagDB.h"

#ifndef WIN32
#include "Audio.h"
#else
#include "AudioWindows.h"
#endif

void 
record(string filename, int secs)
{
  unsigned int i;
  AuFileIO *dest;
  dest = new AuFileIO(filename, MRS_SF_WRITE);
  dest->init();
  fvec window(dest->winSize());
  Audio audio(22050, 1, MRS_AUDIO_REC, dest->winSize());
  for (i=0; i< secs * 22050 / dest->winSize(); i++)
    {
      audio.get(window,i);
      dest->put(window,i);
    }  
}
	
int 
main(int argc, char **argv)
{
  int secs;
  if ((argc < 2)||(argc >4))
    {
      cerr << "Usage :" << argv[0] << " filename [secs]\n";
      exit(1);
    }
  secs = 30;
  if (argc==3) secs = atoi(argv[2]);
  record(argv[1],secs);
  return 0;
}
