/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>
#include "FeatMatrix.h"
#include "MSignal.h"
#include "fmatrix.h"
#include "SoundFileIO.h"
#include "defs.h"
#include "Util.h"
#include "Gain.h"
#include "Hamming.h"
#include "MagFFT.h"
#include "FeatExtractor.h"
#include "Series.h"
#include "MagDB.h"
#include "Sine.h"
#include "Spectral.h"
#include "LabelList.h"
#include "Collection.h"
#include "Gaussian.h"
#include "GMM.h"

 

int
main(int argc, char **argv)
{
  unsigned int cl;
  unsigned int m;
  
  if (argc == 1)
    {
      cerr << "Usage :" << argv[0] <<" classifier train\n";
      exit(1);
    }
  
  string classifierStr = argv[1];
  string trainStr = MARSYAS_MFDIR;
  trainStr += "/featurefiles/";
  trainStr += argv[2];
  
  string destStr = MARSYAS_MFDIR;
  destStr += "/classifiers/";
  destStr += argv[2];
  destStr += ".mcf";
  
  

  FeatMatrix trainMatrix;
  trainMatrix.read(trainStr);
  
  Gaussian classifier;
  classifier.train(&trainMatrix,0);
  classifier.write(destStr);
  cerr << "Writing classifier to file: " << destStr << endl;
  
  return 0;
  

  /* 
  unsigned int numClasses = argc -4;
  unsigned int size;
  string extractorStr = argv[1];

  

  for (cl=0; cl < numClasses; cl++)
    {
      cout << "Class " << cl << " collection is :" << argv[cl+3] << endl;
    }      
  vector <FeatMatrix *> allMatrices;
  unsigned int count = 0;
  allMatrices.push_back(new FeatMatrix());      
  for (cl=0; cl < numClasses; cl++)
    {
      string cname = argv[cl+3];
      cname = cname.substr(0, cname.size()-3); // remove .mf 
      string collectionstr = MARSYAS_MFDIR;
      collectionstr += "/featurefiles/";
      collectionstr += cname;
      collectionstr += extractorStr;
      collectionstr += ".mf";
      ifstream from(collectionstr.c_str());
      while (from >> *(allMatrices[count]))
	{
	  allMatrices.push_back(new FeatMatrix());      	  
	  cout << "reading " << allMatrices[count]->name() << endl;	  
	  count++;
	}      
    }
  allMatrices.pop_back();
  cout << "count " << count << endl;
  
  
  string classifierName = MARSYAS_MFDIR;
  classifierName += "/classifiers/";
  classifierName += argv[argc-1];

  FeatMatrix trainMatrix(allMatrices);


  // GMM classifier(4);
  
  return 0;
  */
}
